use once_cell::sync::Lazy;

pub static CONFIG: Lazy<Config> = Lazy::new(Config::read);

#[derive(serde::Deserialize)]
pub struct Config {
    pub gitlab_id: String,
    pub gitlab_secret: String,
    pub gitlab_url: String,
    pub gitlab_api_url: String,
    pub gitlab_redirect_url: String,
    pub smtp_server: String,
    pub smtp_port: u16,
    pub smtp_user: String,
    pub smtp_password: String
}

impl Config {
    fn read() -> Self {
        let config = std::fs::read_to_string("config.json").expect("Failed to read config.json");
        serde_json::from_str(config.as_str()).expect("Failed to parse config.json")
    }
}
